/* voc 2.1.0 [2019/04/07] for mingw ILP32 on windows xtspaecF */

#ifndef Graph__h
#define Graph__h

#include "SYSTEM.h"
#include "SDL2.h"

typedef
	struct Graph_BitmapDesc *Graph_Bitmap;

typedef
	struct Graph_BitmapDesc {
		char _prvt0[4];
		INT32 w, h;
	} Graph_BitmapDesc;

import void Graph_Bitmap_Finalize (Graph_Bitmap bmp);
#define __Graph_Bitmap_Finalize(bmp) __SEND(__TYPEOF(bmp), 0, void(*)(Graph_Bitmap), (bmp))

typedef
	void (*Graph_CloseBtnProc)(void);

typedef
	struct Graph_Key {
		INT32 code, sym;
		UINT64 mod;
		BOOLEAN repeat;
	} Graph_Key;

typedef
	struct Graph_Event {
		INT32 type;
		Graph_Key key;
		INT32 x, y, xRel, yRel, button;
		UINT64 buttons;
		BOOLEAN down;
		CHAR s[32];
	} Graph_Event;

typedef
	struct Graph_EventQueue {
		INT64 _prvt0;
		char _prvt1[26628];
	} Graph_EventQueue;

typedef
	struct Graph_FontDesc *Graph_Font;

typedef
	struct Graph_FontDesc {
		Graph_Bitmap bmp;
		INT32 charW, charH, charRows, charsInRow;
		struct {
			ADDRESS len[2];
			SDL2_Rect data[1];
		} *sprites;
	} Graph_FontDesc;

typedef
	struct Graph_Region {
		INT32 x, y, w, h;
	} Graph_Region;


import INT32 Graph_randomSeed;

import ADDRESS *Graph_BitmapDesc__typ;
import ADDRESS *Graph_FontDesc__typ;
import ADDRESS *Graph_Key__typ;
import ADDRESS *Graph_Region__typ;
import ADDRESS *Graph_Event__typ;
import ADDRESS *Graph_EventQueue__typ;

import void Graph_AddRegion (INT32 x, INT32 y, INT32 w, INT32 h);
import BOOLEAN Graph_AltPressed (void);
import void Graph_AppendN (INT32 n, CHAR *s, ADDRESS s__len);
import void Graph_Blit (Graph_Bitmap src, Graph_Bitmap dest, INT32 sx, INT32 sy, INT32 sw, INT32 sh, INT32 dx, INT32 dy);
import void Graph_BlitWhole (Graph_Bitmap src, Graph_Bitmap dest, INT32 x, INT32 y);
import INT32 Graph_BmpCol (Graph_Bitmap bmp, INT32 r, INT32 g, INT32 b);
import void Graph_Circle (Graph_Bitmap b, INT32 cx, INT32 cy, INT32 r, INT32 col);
import void Graph_CircleFill (Graph_Bitmap b, INT32 cx, INT32 cy, INT32 r, INT32 col);
import void Graph_ClearBitmap (Graph_Bitmap bmp);
import void Graph_ClearScreen (void);
import void Graph_ClearScreenToColor (INT32 color);
import void Graph_ClearToColor (Graph_Bitmap bmp, INT32 color);
import void Graph_Close (void);
import void Graph_ColorToRGB (INT32 color, INT32 *r, INT32 *g, INT32 *b);
import Graph_Bitmap Graph_CreateBitmap (INT32 w, INT32 h);
import void Graph_CreateStdMousePointer (void);
import BOOLEAN Graph_CtrlPressed (void);
import void Graph_Delay (INT32 n);
import void Graph_DestroyBitmap (Graph_Bitmap bmp);
import void Graph_DrawCharacter (Graph_Bitmap dest, Graph_Font font, INT32 x, INT32 y, CHAR ch, INT32 fg);
import void Graph_DrawCharacterEx (Graph_Bitmap dest, Graph_Bitmap sprite, INT32 x, INT32 y, INT32 color, INT32 bg);
import void Graph_DrawSpriteEx (Graph_Bitmap dest, Graph_Bitmap sprite, INT32 x, INT32 y, INT32 mode, UINT64 flip);
import void Graph_DrawString (Graph_Bitmap dest, Graph_Font font, INT32 x, INT32 y, CHAR *s, ADDRESS s__len, INT32 fg);
import void Graph_Ellipse (Graph_Bitmap bmp, INT32 x, INT32 y, INT32 rx, INT32 ry, INT32 color);
import void Graph_EllipseFill (Graph_Bitmap bmp, INT32 x, INT32 y, INT32 rx, INT32 ry, INT32 color);
import void Graph_FastLine (Graph_Bitmap bmp, INT32 x1, INT32 y1, INT32 x2, INT32 y2, INT32 color);
import void Graph_Flip (void);
import void Graph_FloodFill (Graph_Bitmap bmp, INT32 x, INT32 y, INT32 color);
import void Graph_GetDesktopResolution (INT32 *w, INT32 *h);
import void Graph_GetError (CHAR *s, ADDRESS s__len);
import UINT64 Graph_GetMouseButtons (void);
import Graph_Bitmap Graph_GetMousePointer (void);
import void Graph_GetMousePos (INT32 *x, INT32 *y);
import INT32 Graph_GetPixel (Graph_Bitmap bmp, INT32 x, INT32 y);
import void Graph_GetRealMousePos (INT32 *x, INT32 *y);
import INT32 Graph_GetTicks (void);
import void Graph_HLine (Graph_Bitmap bmp, INT32 x1, INT32 y, INT32 x2, INT32 color);
import Graph_Bitmap Graph_Init (void);
import BOOLEAN Graph_KeyDown (INT32 key);
import BOOLEAN Graph_KeyPressed (void);
import void Graph_Line (Graph_Bitmap bmp, INT32 x1, INT32 y1, INT32 x2, INT32 y2, INT32 color);
import Graph_Bitmap Graph_LoadBitmap (CHAR *filename, ADDRESS filename__len);
import Graph_Font Graph_LoadFont (CHAR *filename, ADDRESS filename__len, INT32 charW, INT32 charH);
import void Graph_LockBitmap (Graph_Bitmap bmp);
import INT32 Graph_MakeCol (INT32 r, INT32 g, INT32 b);
import void Graph_MaskedBlit (Graph_Bitmap src, Graph_Bitmap dest, INT32 sx, INT32 sy, INT32 dx, INT32 dy, INT32 w, INT32 h);
import BOOLEAN Graph_MouseOnScreen (void);
import void Graph_Pause (void);
import BOOLEAN Graph_PollEvent (Graph_Event *event, ADDRESS *event__typ);
import void Graph_PutPixel (Graph_Bitmap bmp, INT32 x, INT32 y, INT32 color);
import void Graph_PutPixelFast (Graph_Bitmap bmp, INT32 x, INT32 y, INT32 color);
import void Graph_PutSeed (INT32 newSeed);
import INT32 Graph_Random (INT32 range);
import void Graph_Randomize (void);
import CHAR Graph_ReadKey (void);
import void Graph_Rect (Graph_Bitmap bmp, INT32 x1, INT32 y1, INT32 x2, INT32 y2, INT32 color);
import void Graph_RectFill (Graph_Bitmap bmp, INT32 x1, INT32 y1, INT32 x2, INT32 y2, INT32 color);
import void Graph_RepeatFlip (void);
import void Graph_SetAlpha (Graph_Bitmap bmp, INT32 alpha);
import void Graph_SetColorKey (Graph_Bitmap bmp, INT32 color);
import void Graph_SetFPS (INT32 fps);
import void Graph_SetMouseFocus (INT32 x, INT32 y);
import void Graph_SetMousePointer (Graph_Bitmap bmp, INT32 x, INT32 y);
import void Graph_SetRegion (INT32 x, INT32 y, INT32 w, INT32 h);
import void Graph_SetSizeStep (INT32 w, INT32 h);
import void Graph_SetStdMousePointer (void);
import void Graph_SetWindowTitle (CHAR *title, ADDRESS title__len);
import void Graph_Settings (INT32 w, INT32 h, UINT64 flags);
import BOOLEAN Graph_ShiftPressed (void);
import void Graph_ShowMouse (BOOLEAN show);
import void Graph_StartTextInput (void);
import void Graph_StopTextInput (void);
import void Graph_Str (INT32 n, CHAR *s, ADDRESS s__len);
import void Graph_StretchBlit (Graph_Bitmap src, Graph_Bitmap dest, INT32 sx, INT32 sy, INT32 sw, INT32 sh, INT32 dx, INT32 dy, INT32 dw, INT32 dh);
import void Graph_SwitchToFullscreen (void);
import void Graph_SwitchToWindowed (void);
import void Graph_ToggleFullscreen (void);
import REAL Graph_Uniform (void);
import void Graph_UnlockBitmap (Graph_Bitmap bmp);
import void Graph_UnsetRegion (void);
import void Graph_VLine (Graph_Bitmap bmp, INT32 x, INT32 y1, INT32 y2, INT32 color);
import INT32 Graph_Val (CHAR *s, ADDRESS s__len);
import void Graph_WaitEvents (INT32 timeout);
import BOOLEAN Graph_WindowShown (void);
import void *Graph__init(void);


#endif // Graph
